package com.qmth.distributed.print.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qmth.distributed.print.business.bean.dto.ExamStudentCourseClassDto;
import com.qmth.distributed.print.business.bean.dto.ExamStudentCourseDto;
import com.qmth.distributed.print.business.bean.dto.ExamStudentDto;
import com.qmth.distributed.print.business.bean.dto.pdf.ExamStudentInfo;
import com.qmth.distributed.print.business.entity.ExamStudent;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 考生 Mapper 接口
 * </p>
 *
 * @author xf
 * @since 2021-03-23
 */
public interface ExamStudentMapper extends BaseMapper<ExamStudent> {

    @SuppressWarnings("MybatisXMapperMethodInspection")
    Map<String, Object> getStudentDetail(Long id);

    /**
     * 根据班级id查询考生，班级可以是教学班或行政班（两表查）
     *
     * @param schoolId 学校id
     * @param classId  班级id
     * @return 考生查询结果
     */
    List<ExamStudent> listExamStudentBySchoolIdAndClazzId(@Param("schoolId") Long schoolId, @Param("classId") String classId);


    List<ExamStudentCourseClassDto> listMarkStudentInfo(@Param("examId") Long examId, @Param("paperNumber") String paperNumber, @Param("paperType") String paperType);

    List<ExamStudent> listByExamDetailCourseIdNotIntMarkStudent(@Param("examDetailCourseId") Long examDetailCourseId, @Param("paperType") String paperType);

    List<ExamStudentInfo> listByExamDetailCourseId(Long examDetailCourseId);
}
