package com.qmth.teachcloud.mark.dto.mark.score;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.entity.MarkQuestion;
import com.qmth.teachcloud.common.enums.BasicExamStudentStatusEnum;
import com.qmth.teachcloud.common.enums.ScanStatus;
import com.qmth.teachcloud.common.enums.mark.SubjectiveStatus;
import com.qmth.teachcloud.mark.dto.mark.ScoreItem;
import org.apache.commons.lang3.StringUtils;

import java.util.LinkedList;
import java.util.List;

public class StudentScoreDetailDto {

    public static final String SPLIT = ";";
    @JsonSerialize(using = ToStringSerializer.class)
    private Long studentId;
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examId;
    private String courseCode;
    private String courseName;
    private String paperNumber;
    private String studentName;
    private String studentCode;
    private String secretNumber;
    private String college;
    private String majorName;
    private String teachClassName;
    private String className;
    private String objectiveScore;
    private String subjectiveScore;
    private String totalScore;
    private String objectiveScoreList;
    private String subjectiveScoreList;
    private String checkUserId;
    private String checkUserLoginName;
    private String checkUserName;
    private Long checkTime;
    private String sheetPath;
    private List<SheetUrlDto> sheetUrls;
    private Long examStartTime;
    private Long examEndTime;
    private ScanStatus scanStatus;
    private SubjectiveStatus subjectiveStatus;
    private Boolean absent;
    private Boolean omrAbsent;
    private String statusDisplay;
    private Boolean upload;
    // 主观题检查标记
    private Boolean subjectiveCheckFlag;
    // 客观题标记
    private Boolean objectiveCheckFlag;
    private BasicExamStudentStatusEnum studentStatus;
    private String studentStatusDisplay;
    private String collegeName;

    public String getCollegeName() {
        return collegeName;
    }

    public void setCollegeName(String collegeName) {
        this.collegeName = collegeName;
    }

    public Long getStudentId() {
        return studentId;
    }

    public void setStudentId(Long studentId) {
        this.studentId = studentId;
    }

    public Long getExamId() {
        return examId;
    }

    public void setExamId(Long examId) {
        this.examId = examId;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getPaperNumber() {
        return paperNumber;
    }

    public void setPaperNumber(String paperNumber) {
        this.paperNumber = paperNumber;
    }

    public String getStudentName() {
        return studentName;
    }

    public void setStudentName(String studentName) {
        this.studentName = studentName;
    }

    public String getStudentCode() {
        return studentCode;
    }

    public void setStudentCode(String studentCode) {
        this.studentCode = studentCode;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }

    public String getCollege() {
        return college;
    }

    public void setCollege(String college) {
        this.college = college;
    }

    public String getMajorName() {
        return majorName;
    }

    public void setMajorName(String majorName) {
        this.majorName = majorName;
    }

    public String getTeachClassName() {
        return teachClassName;
    }

    public void setTeachClassName(String teachClassName) {
        this.teachClassName = teachClassName;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getObjectiveScore() {
        return objectiveScore;
    }

    public void setObjectiveScore(String objectiveScore) {
        this.objectiveScore = objectiveScore;
    }

    public String getSubjectiveScore() {
        return subjectiveScore;
    }

    public void setSubjectiveScore(String subjectiveScore) {
        this.subjectiveScore = subjectiveScore;
    }

    public String getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(String totalScore) {
        this.totalScore = totalScore;
    }

    public String getObjectiveScoreList() {
        return objectiveScoreList;
    }

    public void setObjectiveScoreList(String objectiveScoreList) {
        this.objectiveScoreList = objectiveScoreList;
    }

    public String getSubjectiveScoreList() {
        return subjectiveScoreList;
    }

    public void setSubjectiveScoreList(String subjectiveScoreList) {
        this.subjectiveScoreList = subjectiveScoreList;
    }

    public String getCheckUserId() {
        return checkUserId;
    }

    public void setCheckUserId(String checkUserId) {
        this.checkUserId = checkUserId;
    }

    public String getCheckUserLoginName() {
        return checkUserLoginName;
    }

    public void setCheckUserLoginName(String checkUserLoginName) {
        this.checkUserLoginName = checkUserLoginName;
    }

    public String getCheckUserName() {
        return checkUserName;
    }

    public void setCheckUserName(String checkUserName) {
        this.checkUserName = checkUserName;
    }

    public Long getCheckTime() {
        return checkTime;
    }

    public void setCheckTime(Long checkTime) {
        this.checkTime = checkTime;
    }

    public String getSheetPath() {
        return sheetPath;
    }

    public void setSheetPath(String sheetPath) {
        this.sheetPath = sheetPath;
    }

    public List<SheetUrlDto> getSheetUrls() {
        return sheetUrls;
    }

    public void setSheetUrls(List<SheetUrlDto> sheetUrls) {
        this.sheetUrls = sheetUrls;
    }

    public Long getExamStartTime() {
        return examStartTime;
    }

    public void setExamStartTime(Long examStartTime) {
        this.examStartTime = examStartTime;
    }

    public Long getExamEndTime() {
        return examEndTime;
    }

    public void setExamEndTime(Long examEndTime) {
        this.examEndTime = examEndTime;
    }

    public ScanStatus getScanStatus() {
        return scanStatus;
    }

    public void setScanStatus(ScanStatus scanStatus) {
        this.scanStatus = scanStatus;
    }

    public SubjectiveStatus getSubjectiveStatus() {
        return subjectiveStatus;
    }

    public void setSubjectiveStatus(SubjectiveStatus subjectiveStatus) {
        this.subjectiveStatus = subjectiveStatus;
    }

    public Boolean getAbsent() {
        return absent;
    }

    public void setAbsent(Boolean absent) {
        this.absent = absent;
    }

    public Boolean getOmrAbsent() {
        return omrAbsent;
    }

    public void setOmrAbsent(Boolean omrAbsent) {
        this.omrAbsent = omrAbsent;
    }

    public String getStatusDisplay() {
        return statusDisplay;
    }

    public void setStatusDisplay(String statusDisplay) {
        this.statusDisplay = statusDisplay;
    }

    public Boolean getUpload() {
        return upload;
    }

    public void setUpload(Boolean upload) {
        this.upload = upload;
    }

    public Boolean getSubjectiveCheckFlag() {
        return subjectiveCheckFlag;
    }

    public void setSubjectiveCheckFlag(Boolean subjectiveCheckFlag) {
        this.subjectiveCheckFlag = subjectiveCheckFlag;
    }

    public Boolean getObjectiveCheckFlag() {
        return objectiveCheckFlag;
    }

    public void setObjectiveCheckFlag(Boolean objectiveCheckFlag) {
        this.objectiveCheckFlag = objectiveCheckFlag;
    }

    public BasicExamStudentStatusEnum getStudentStatus() {
        return studentStatus;
    }

    public void setStudentStatus(BasicExamStudentStatusEnum studentStatus) {
        this.studentStatus = studentStatus;
    }

    public String getStudentStatusDisplay() {
        return this.studentStatusDisplay;
    }

    public void setStudentStatusDisplay(String studentStatusDisplay) {
        this.studentStatusDisplay = studentStatusDisplay;
    }

    public List<ScoreItem> getScoreList(boolean objective, List<MarkQuestion> questionList) {
        List<ScoreItem> scoreList = new LinkedList<ScoreItem>();
        try {
            String[] values = StringUtils.split(objective ? objectiveScoreList : subjectiveScoreList, SPLIT);
            int i = 0;
            for (String value : values) {
                i++;
                if (questionList.size() < i) {
                    break;
                }
                MarkQuestion question = questionList.get(i - 1);
                if (question.getTotalScore() == null || question.getTotalScore() == 0) {
                    continue;
                }
                ScoreItem item = ScoreItem.parse(value, objective);
                item.setObjective(objective);
                item.setMainNumber(question.getMainNumber());
                item.setTitle(question.getMainTitle());
                item.setTotalScore(question.getTotalScore());
                item.setSubNumber(question.getSubNumber());
                if (item != null) {
                    scoreList.add(item);
                }
            }
        } catch (Exception e) {
        }
        return scoreList;
    }
}
