package com.qmth.teachcloud.obe.been.result;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * @Description: obe成绩管理结果
 * @Author: CaoZixuan
 * @Date: 2024-06-13
 */
public class ObeScoreResult implements Serializable {

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "课程大纲id")
    private Long obeCourseOutlineId;

    @ApiModelProperty(value = "课程大纲名称")
    private String obeCourseOutlineName;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "培养方案id")
    private Long cultureProgramId;

    @ApiModelProperty(value = "培养方案名称")
    private String cultureProgramName;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "课程id")
    private Long courseId;

    @ApiModelProperty(value = "课程名称")
    private String courseName;

    @ApiModelProperty(value = "课程编号")
    private String courseCode;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "责任人id")
    private Long userId;

    @ApiModelProperty(value = "责任人名称")
    private String userName;

    @ApiModelProperty(value = "责任人登录名称")
    private String userLoginName;

    @JsonSerialize(using = ToStringSerializer.class)
    @ApiModelProperty(value = "学期id")
    private Long semesterId;

    @ApiModelProperty(value = "学期名称")
    private String semesterName;

    public Long getObeCourseOutlineId() {
        return obeCourseOutlineId;
    }

    public void setObeCourseOutlineId(Long obeCourseOutlineId) {
        this.obeCourseOutlineId = obeCourseOutlineId;
    }

    public String getObeCourseOutlineName() {
        return obeCourseOutlineName;
    }

    public void setObeCourseOutlineName(String obeCourseOutlineName) {
        this.obeCourseOutlineName = obeCourseOutlineName;
    }

    public Long getCultureProgramId() {
        return cultureProgramId;
    }

    public void setCultureProgramId(Long cultureProgramId) {
        this.cultureProgramId = cultureProgramId;
    }

    public String getCultureProgramName() {
        return cultureProgramName;
    }

    public void setCultureProgramName(String cultureProgramName) {
        this.cultureProgramName = cultureProgramName;
    }

    public Long getCourseId() {
        return courseId;
    }

    public void setCourseId(Long courseId) {
        this.courseId = courseId;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getUserLoginName() {
        return userLoginName;
    }

    public void setUserLoginName(String userLoginName) {
        this.userLoginName = userLoginName;
    }

    public Long getSemesterId() {
        return semesterId;
    }

    public void setSemesterId(Long semesterId) {
        this.semesterId = semesterId;
    }

    public String getSemesterName() {
        return semesterName;
    }

    public void setSemesterName(String semesterName) {
        this.semesterName = semesterName;
    }
}
