package com.qmth.teachcloud.obe.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.teachcloud.common.base.BaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;

/**
 * <p>
 * 课程权重设置
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-02-22
 */
@ApiModel(value="CourseWeight对象", description="课程权重设置")
public class ObeCourseWeight extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "课程大纲id")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long obeCourseOutlineId;

    @ApiModelProperty(value = "学校id")
    private Long schoolId;

    @ApiModelProperty(value = "课程目标表id")
    private Long targetId;

    @ApiModelProperty(value = "课程评价表id")
    private Long evaluationId;

    @ApiModelProperty(value = "使用状态 1:使用 0:未使用")
    private Boolean enable;

    @ApiModelProperty(value = "权重")
    private BigDecimal weight;

    @ApiModelProperty(value = "目标分值")
    private BigDecimal targetScore;

    public Long getObeCourseOutlineId() {
        return obeCourseOutlineId;
    }

    public void setObeCourseOutlineId(Long obeCourseOutlineId) {
        this.obeCourseOutlineId = obeCourseOutlineId;
    }

    public Long getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Long schoolId) {
        this.schoolId = schoolId;
    }

    public Long getTargetId() {
        return targetId;
    }

    public void setTargetId(Long targetId) {
        this.targetId = targetId;
    }

    public Long getEvaluationId() {
        return evaluationId;
    }

    public void setEvaluationId(Long evaluationId) {
        this.evaluationId = evaluationId;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public BigDecimal getWeight() {
        return weight;
    }

    public void setWeight(BigDecimal weight) {
        this.weight = weight;
    }

    public BigDecimal getTargetScore() {
        return targetScore;
    }

    public void setTargetScore(BigDecimal targetScore) {
        this.targetScore = targetScore;
    }
}
