package com.qmth.teachcloud.obe.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.teachcloud.obe.been.dto.FinalScoreDto;
import com.qmth.teachcloud.obe.been.result.FinalScoreResult;
import com.qmth.teachcloud.obe.entity.TCFinalScore;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 期末考试成绩表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TCFinalScoreMapper extends BaseMapper<TCFinalScore> {

    /**
     * 期末成绩列表（分页）
     *
     * @param iPage
     * @param cultureProgramId
     * @param courseId
     * @return
     */
    public IPage<TCFinalScore> finalScoreList(IPage<Map> iPage, @Param("cultureProgramId") Long cultureProgramId, @Param("courseId") Long courseId);

    /**
     * 查找期末成绩分数图
     *
     * @param cultureProgramId
     * @param courseId
     * @return
     */
    public FinalScoreDto finalScoreScoreOverView(@Param("cultureProgramId") Long cultureProgramId, @Param("courseId") Long courseId);

    /**
     * 查找期末成绩分数区间
     *
     * @param cultureProgramId
     * @param courseId
     * @param start
     * @param end
     * @return
     */
    public int getCountByScoreRange(@Param("cultureProgramId") Long cultureProgramId, @Param("courseId") Long courseId, @Param("start") Double start, @Param("end") Double end);

    /**
     * 查找考生成绩
     *
     * @param cultureProgramId
     * @param courseId
     * @return
     */
    public List<FinalScoreResult> examStudentOverview(@Param("cultureProgramId") Long cultureProgramId, @Param("courseId") Long courseId);
}
