package com.qmth.teachcloud.obe.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.teachcloud.obe.entity.TCUsualScore;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 平常作业成绩表 服务类
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TCUsualScoreService extends IService<TCUsualScore> {

    /**
     * 平时成绩导入
     *
     * @param file
     * @param cultureProgramId
     * @param courseId
     * @return 结果
     */
    public Map<String, String> usualScoreExcelImport(MultipartFile file, Long cultureProgramId, Long courseId) throws IOException;

    /**
     * 平时成绩列表（分页）
     *
     * @param iPage
     * @param cultureProgramId
     * @param courseId
     * @param paperNumber
     * @return
     */
    public IPage<TCUsualScore> usualScoreList(IPage<Map> iPage, Long cultureProgramId, Long courseId, String paperNumber);

    /**
     * 根据考试id/课程编码/试卷编码查询数据库数据
     *
     * @param cultureProgramId
     * @param courseId
     * @param paperNumber
     * @return
     */
    public List<TCUsualScore> queryUsualScore(Long cultureProgramId, Long courseId, String paperNumber);
}
